# MapperReadKeyValueRepo

open class MapperReadKeyValueRepo < FromKey , FromValue , ToKey , ToValue >(to: ReadKeyValueRepo < ToKey , ToValue >, mapper: MapperRepo < FromKey , FromValue , ToKey , ToValue >) : ReadKeyValueRepo < FromKey , FromValue > , MapperRepo < FromKey , FromValue , ToKey , ToValue > (source)

## Constructors

MapperReadKeyValueRepo
Link copied to clipboard
constructor(to: ReadKeyValueRepo < ToKey , ToValue >, mapper: MapperRepo < FromKey , FromValue , ToKey , ToValue >)

## Properties

keyMapper
Link copied to clipboard
open override val keyMapper : SimpleSuspendableMapper < FromKey , ToKey >
valueMapper
Link copied to clipboard
open override val valueMapper : SimpleSuspendableMapper < FromValue , ToValue >

## Functions

asReadCRUDRepo
Link copied to clipboard
fun < K , V > ReadKeyValueRepo < K , V >. asReadCRUDRepo (): ReadCRUDFromKeyValueRepo < V , K >
asReadKeyValuesRepo
Link copied to clipboard
fun < K , V , VI : Iterable < V >> ReadKeyValueRepo < K , VI >. asReadKeyValuesRepo (): ReadKeyValuesFromKeyValueRepo < K , V , VI >
cached
Link copied to clipboard
fun < Key , Value > ReadKeyValueRepo < Key , Value >. cached (kvCache: KVCache < Key , Value >, locker: SmartRWLocker = SmartRWLocker()): ReadKeyValueCacheRepo < Key , Value >
fun < Key , Value > ReadKeyValueRepo < Key , Value >. cached (kvCache: KeyValueRepo < Key , Value >, locker: SmartRWLocker = SmartRWLocker()): FullReadKeyValueCacheRepo < Key , Value >
contains
Link copied to clipboard
open suspend override fun contains (key: FromKey ): Boolean
count
Link copied to clipboard
open suspend override fun count (): Long
diff
Link copied to clipboard
suspend fun < Id , Registered > ReadKeyValueRepo < Id , Registered >. diff (other: Map < Id , Registered >): MapDiff < Id , Registered >
directlyCached
Link copied to clipboard
fun < Key , Value > ReadKeyValueRepo < Key , Value >. directlyCached (kvCache: KeyValueRepo < Key , Value >, locker: SmartRWLocker = SmartRWLocker()): DirectFullReadKeyValueCacheRepo < Key , Value >
get
Link copied to clipboard
open suspend override fun get (k: FromKey ): FromValue ?
getAll
Link copied to clipboard
open suspend override fun getAll (): Map < FromKey , FromValue >
keys
Link copied to clipboard
open suspend override fun keys (pagination: Pagination , reversed: Boolean ): PaginationResult < FromKey >

This method should use sorted by Keys search and return the PaginationResult. By default, it should use ascending sort for Keys

open suspend override fun keys (v: FromValue , pagination: Pagination , reversed: Boolean ): PaginationResult < FromKey >

This method should use sorted by Keys search and return the PaginationResult. By default, it should use ascending sort for Keys.

maxPagePagination
Link copied to clipboard
inline suspend fun ReadKeyValueRepo <*, *>. maxPagePagination (): SimplePagination
toInnerKey
Link copied to clipboard
open suspend override fun ToKey . toInnerKey (): FromKey
toInnerValue
Link copied to clipboard
open suspend override fun ToValue . toInnerValue (): FromValue
toOutKey
Link copied to clipboard
open suspend override fun FromKey . toOutKey (): ToKey
toOutValue
Link copied to clipboard
open suspend override fun FromValue . toOutValue (): ToValue
values
Link copied to clipboard
open suspend override fun values (pagination: Pagination , reversed: Boolean ): PaginationResult < FromValue >

This method should use sorted by Keys search and return the PaginationResult. By default, it should use ascending sort for Keys

withMapper
Link copied to clipboard
inline fun < FromKey , FromValue , ToKey , ToValue > ReadKeyValueRepo < ToKey , ToValue >. withMapper (mapper: MapperRepo < FromKey , FromValue , ToKey , ToValue >): ReadKeyValueRepo < FromKey , FromValue >
inline fun < FromKey , FromValue , ToKey , ToValue > ReadKeyValueRepo < ToKey , ToValue >. withMapper (noinline keyFromToTo: suspend FromKey .() -> ToKey = { this as ToKey }, noinline valueFromToTo: suspend FromValue .() -> ToValue = { this as ToValue }, noinline keyToToFrom: suspend ToKey .() -> FromKey = { this as FromKey }, noinline valueToToFrom: suspend ToValue .() -> FromValue = { this as FromValue }): ReadKeyValueRepo < FromKey , FromValue >